
function [BestSol,Emax,BestCosts,Fit,Yfinal,sepresults,YYY] = QPSO(s,X,rt,upload)
% out = QPSO(problem, params)
display('QPSO');
% problem.CostFunction = @(x) Sphere(x);  % Cost Function
problem.nVar = 2;       % Number of Unknown (Decision) Variables
problem.VarMin =  -1;  % Lower Bound of Decision Variables
problem.VarMax =  1;   % Upper Bound of Decision Variables
plotOpt=1;
Emax=1;

%% Parameters of PSO

params.MaxIt = 50;        % Maximum Number of Iterations
params.nPop = 200;           % Population Size (Swarm Size)
params.u = rand(1,problem.nVar);               % Intertia Coefficient
params.beta = 0.5;             % Contraction expansion coefficient
params.chi = rand;             % a random value between 0 and 1
params.ShowIterInfo = true; % Flag for Showing Iteration Informatin
    %% Problem Definiton

%     CostFunction = problem.CostFunction;  % Cost Function

    nVar = problem.nVar;        % Number of Unknown (Decision) Variables

    VarSize = [1 nVar];         % Matrix Size of Decision Variables

    VarMin = problem.VarMin;	% Lower Bound of Decision Variables
    VarMax = problem.VarMax;    % Upper Bound of Decision Variables


    %% Parameters of PSO

    MaxIt = params.MaxIt;   % Maximum Number of Iterations

    nPop = params.nPop;     % Population Size (Swarm Size)

    u = params.u;           % Intertia Coefficient
    beta = params.beta;     %Contraction expansion coeffecient
    chi = params.chi;       % random values between [0,1]

    % The Flag for Showing Iteration Information
    ShowIterInfo = params.ShowIterInfo;    

    
    %% Initialization

    % The Particle Template
    empty_particle.Position = [];
    empty_particle.PPattractor = [];
    empty_particle.Cost = [];
    empty_particle.Best.Position = [];
    empty_particle.Best.Cost = [];

    % Create Population Array
    particle = repmat(empty_particle, nPop, 1);

    % Initialize Global Best
    GlobalBest.Cost = inf;
    GlobalBestPosition = 0;
    GlobalBestValue = inf;
    MBest=0;

%     fprintf('s: %g For %g time:\n ',s,rt);
    % Initialize Population Members
    for i=1:nPop

        % Generate Random Solution
        particle(i).Position = unifrnd(VarMin, VarMax, VarSize);

        % Initialize attractor
        particle(i).PPattractor = zeros(VarSize);

        % Evaluation
        particle(i).Cost = FitnessFun(particle(i).Position,X) ;
%         particle(i).Cost = CostFunction(particle(i).Position);

        % Update the Personal Best
        particle(i).Best.Position = particle(i).Position;
        particle(i).Best.Cost = particle(i).Cost;

        % Update Global Best
        if particle(i).Best.Cost < GlobalBest.Cost
            GlobalBest = particle(i).Best;
        end

    end

    % Array to Hold Best Cost Value on Each Iteration
    BestCosts = zeros(MaxIt, 1);


    %% Main Loop of PSO

    for it=1:MaxIt
        adder=0;
        for i=1:nPop

            % Update attractor
            particle(i).PPattractor =particle(i).Best.Position+(1-chi).*GlobalBest.Position;
            % update adder and mean best
            adder=adder+particle(i).Best.Position;
            MBest=(adder+particle(i).Best.Position)./nPop;
            
            % Update Position
            if rand < 0.5
                particle(i).Position = particle(i).Best.Position +beta.*abs(MBest-particle(i).Position).*log(1./u);
            else
                particle(i).Position = particle(i).Best.Position -beta.*abs(MBest-particle(i).Position).*log(1./u);
            end
           
            % Evaluation
%             particle(i).Cost = CostFunction(particle(i).Position);
              particle(i).Cost = FitnessFun(particle(i).Position,X);

            % Update Personal Best
            if particle(i).Cost < particle(i).Best.Cost

                particle(i).Best.Position = particle(i).Position;
                particle(i).Best.Cost = particle(i).Cost;

                % Update Global Best
                if particle(i).Best.Cost < GlobalBest.Cost
                    GlobalBest = particle(i).Best;
                    Emax = it;
                end            

            end

        end

        % Store the Best Cost Value
        BestCosts(it) = GlobalBest.Cost;

    Fit(rt,it) = GlobalBest.Cost;
    record(it) = GlobalBest.Cost;%最大值记录
    sepresults(1).fitness(it,:)=GlobalBest.Cost;
    sepresults(1).postion(it,:)=GlobalBest.Position;
       
    end
    
  pop = particle;
  BestSol = GlobalBest.Position;
  BestCosts = GlobalBest.Cost;
  
  figure(7);plot(record,'LineWidth',2);title('QPSO收敛过程');
  xlabel('e','fontname','Times New Roman','fontsize',9);
  ylabel('fitness','fontname','Times New Roman','fontsize',9);
  box off
  hold on
 
 fig7 = sprintf( '7shoulian%d',rt);
    
   exportgraphics(gcf,[upload,'\14QPSO\',fig7,'.jpg'],'Resolution',600);
%    saveas(gcf,[upload,'\11SCA\',fig7,'.jpg']);
   upload1 = [upload,'14QPSO\'];
   [sepresults,Yfinal,YYY] = SepChoose2(rt,sepresults,X,plotOpt,upload1);
   save([upload,'14QPSO\QPSO02']);

    
end